/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 *@Note
 GPIỌ
 PA0

*/

#include "debug.h"

/* Global define */

/* Global Variable */

/*********************************************************************
 * @fn      GPIO_Toggle_INIT
 *
 * @brief   Initializes GPIOA.0
 *
 * @return  none
 */
//s32 ADC1_Calibrattion_Val = 0;
__IO uint16_t ADC_ConvertedValue[6]={0};

/**
  * @brief  ADC GPIO ʼ
  * @param  
  * @retval 
  */
static void ADCx_GPIO_Config(void)
{
    GPIO_InitTypeDef GPIO_InitStructure={0};

    //  ADC IO˿ʱ
    RCC_APB2PeriphClockCmd ( RCC_APB2Periph_GPIOA, ENABLE );

    //  ADC IO ģʽ
    GPIO_InitStructure.GPIO_Pin =   GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;

    // ʼ ADC IO
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}

/**
  * @brief  ADCģʽ
  * @param  
  * @retval 
  */
static void ADCx_Mode_Config(void)
{
    DMA_InitTypeDef DMA_InitStructure={0};
    ADC_InitTypeDef ADC_InitStructure={0};
    NVIC_InitTypeDef NVIC_InitStructure={0};

    // DMAʱ
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);
    // ADCʱ
    RCC_APB2PeriphClockCmd ( RCC_APB2Periph_ADC1, ENABLE );

    // λDMA
    DMA_DeInit(DMA1_Channel1);

    //  DMA ʼṹ
    // ַΪADC ݼĴַ
    DMA_InitStructure.DMA_PeripheralBaseAddr = ( u32 ) ( & ( ADC1->RDATAR ) );

    // 洢ַ
    DMA_InitStructure.DMA_MemoryBaseAddr = (u32)ADC_ConvertedValue;

    // Դ
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;

    // СӦõĿĵصĴС
    DMA_InitStructure.DMA_BufferSize = 6;

    // Ĵֻһַõ
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;

    // 洢ַ
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;

    // ݴСΪֽ֣
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;

    // ڴݴСҲΪ֣ݴСͬ
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;

    // ѭģʽ
    DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;

    // DMA ͨȼΪߣʹһDMAͨʱȼòӰ
    DMA_InitStructure.DMA_Priority = DMA_Priority_High;

    // ֹ洢洢ģʽΪǴ赽洢
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;

    // ʼDMA
    DMA_Init(DMA1_Channel1, &DMA_InitStructure);

    // ʹ DMA ͨ
    DMA_Cmd(DMA1_Channel1 , ENABLE);

    // ADC ģʽ
    // ֻʹһADCڵģʽ
    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;

    // ɨģʽ
    ADC_InitStructure.ADC_ScanConvMode = ENABLE ;

    // תģʽ
    ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;

    // ⲿת
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_Ext_IT11_TIM8_TRGO;

    // תҶ
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;

    // תͨ
    ADC_InitStructure.ADC_NbrOfChannel = 6;

    // ʼADC
    ADC_Init(ADC1, &ADC_InitStructure);

    // ADCʱӣΪPCLK28Ƶ9MHz
    RCC_ADCCLKConfig(RCC_PCLK2_Div8);

    // ADC ͨת˳Ͳʱ
    ADC_RegularChannelConfig(ADC1, ADC_Channel_0, 1, ADC_SampleTime_55Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_1, 2, ADC_SampleTime_55Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_2, 3, ADC_SampleTime_55Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_3, 4, ADC_SampleTime_55Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 5, ADC_SampleTime_55Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_5, 6, ADC_SampleTime_55Cycles5);

    // ʹADC DMA 
    ADC_DMACmd(ADC1, ENABLE);

    // ADC ʼת
    ADC_Cmd(ADC1, ENABLE);

    // ʼADC У׼Ĵ
    ADC_ResetCalibration(ADC1);
    // ȴУ׼Ĵʼ
    while(ADC_GetResetCalibrationStatus(ADC1));

    // ADCʼУ׼
    ADC_StartCalibration(ADC1);
    // ȴУ׼
    while(ADC_GetCalibrationStatus(ADC1));


    ADC_ExternalTrigConvCmd(ADC1, ENABLE);

    //DMA1ͨ4 NVIC 
              NVIC_InitStructure.NVIC_IRQChannel =  DMA1_Channel1_IRQn;
              NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=0 ;//ռȼ3
              NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;        //ȼ3
              NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //IRQͨʹ
              NVIC_Init(&NVIC_InitStructure);

              DMA_ITConfig(DMA1_Channel1, DMA_IT_TC, ENABLE);

}

/**
  * @brief  ADCʼ
  * @param  
  * @retval 
  */
void ADCx_Init(void)
{
    ADCx_GPIO_Config();
    ADCx_Mode_Config();
}


void TIM2_Init(u16 Period,u16 Prescaler)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    TIM_OCInitTypeDef TIM_OCInitStructure={0};
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2,ENABLE);

    TIM_TimeBaseStructure.TIM_Prescaler = Prescaler-1;              //ԤƵϵ
    TIM_TimeBaseStructure.TIM_Period = Period-1;                    //
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;     //ϼģʽ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;         //ʱʱӲƵΪ72MHz
    TIM_TimeBaseInit(TIM2,&TIM_TimeBaseStructure);                  //ʼ

    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;               //PWM1ģʽ
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;   //ʹ
    TIM_OCInitStructure.TIM_Pulse = Period/2;                       //ȽϼĴֵ
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;        //Ƚƥɺ
    TIM_OC2Init(TIM2, & TIM_OCInitStructure);                       //ʼ

    TIM_Cmd(TIM2,ENABLE);                                           //ʱʹ
    TIM_InternalClockConfig(TIM2);                                  //ʱڲʱʹ
    TIM_OC2PreloadConfig(TIM2, TIM_OCPreload_Enable);               //װʹ
    TIM_UpdateDisableConfig(TIM2, DISABLE);
}


void EXTI_Event_Init(void)
{
    EXTI_InitTypeDef EXTI_InitStructure={0};
    GPIO_InitTypeDef GPIO_InitStructure={0};

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOC, ENABLE );
    RCC_APB2PeriphClockCmd( RCC_APB2Periph_AFIO, ENABLE );

    GPIO_EXTILineConfig( GPIO_PortSourceGPIOC, GPIO_PinSource11 );

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD;
    GPIO_Init(GPIOC, &GPIO_InitStructure);

    EXTI_InitStructure.EXTI_Line = EXTI_Line11;
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Event;
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;
    EXTI_Init(&EXTI_InitStructure);
}

/*********************************************END OF FILE**********************/
volatile u8 flag=0;
int main(void)
{

    Delay_Init();
    USART_Printf_Init(115200);
    ADCx_Init();
//    TIM2_Init(10000,7200);
    EXTI_Event_Init();
    while(1)
    {
//                    Delay_Ms(50);

       if (flag==1) {
                        flag=0;
                        printf("\r\n CH0 value =%04d\r\n",ADC_ConvertedValue[0]);
                        printf("\r\n CH1 value =%04d\r\n",ADC_ConvertedValue[1]);
                        printf("\r\n CH2 value =%04d\r\n",ADC_ConvertedValue[2]);
                        printf("\r\n CH3 value =%04d\r\n",ADC_ConvertedValue[3]);
                        printf("\r\n CH4 value =%04d\r\n",ADC_ConvertedValue[4]);
                        printf("\r\n CH5 value =%04d\r\n",ADC_ConvertedValue[5]);
                      }

    }
}

void DMA1_Channel1_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void DMA1_Channel1_IRQHandler(void)
{
    if(DMA_GetITStatus(DMA1_IT_TC1)!= RESET)    //DMAɱ־
    {
//        DMA_SetCurrDataCounter(DMA1_Channel2,0);
        printf("DMA-OK\r\n");
        flag=1;
        DMA_ClearITPendingBit(DMA1_IT_TC1);     //жϱ־
    }
}

